Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoToVRML2Action Class Reference
[Actions]

`#include <Inventor/actions/SoToVRML2Action.h>`

Inheritance diagram for SoToVRML2Action:

List of all members.

## Detailed Description

The SoToVRML2Action class builds a new scene graph, using only VRML97/VRML2 nodes.

This action is used for converting a scene graph of VRML1/Coin nodes to a new scene graph using only VRML97/VRML2 nodes.

Due to the basic differences between VRML1/Coin and VRML2 (the latter does not really have a traversal state) the new scene graph will typically be somewhat larger. To minimize this effect the action tries to re-use nodes when possible.

VRML1 nodes will be converted to its direct equivalent VRML2 node, while Coin nodes with no VRML2 equivalent are converted to IndexedFaceSet. If the DrawStyle is POINTS, all geometry will be built using PointSet; if it is LINES IndexedLineSet is used.

Here's a basic usage example of this action, in the form of a complete, stand-alone program:

      #include <Inventor/SoDB.h>
      #include <Inventor/SoInteraction.h>
      #include <Inventor/SoInput.h>
      #include <Inventor/SoOutput.h>
      #include <Inventor/actions/SoWriteAction.h>
      #include <Inventor/actions/SoToVRML2Action.h>
      #include <Inventor/nodes/SoSeparator.h>
      #include <Inventor/VRMLnodes/SoVRMLGroup.h>

      int
      main(int argc, char *argv[])
      {
        SoDB::init();
        SoInteraction::init();
        SoInput in;
        in.openFile(argv[1]);
        printf("Reading...\n");
        SoSeparator *root = SoDB::readAll(&in);

        if (root) {
          root->ref();
          SbString hdr = in.getHeader();
          in.closeFile();

          printf("Converting...\n");
          SoToVRML2Action tovrml2;
          tovrml2.apply(root);
          SoVRMLGroup *newroot = tovrml2.getVRML2SceneGraph();
          newroot->ref();
          root->unref();

          printf("Writing...\n");

          SoOutput out;
          out.openFile("out.wrl");
          out.setHeaderString("#VRML V2.0 utf8");
          SoWriteAction wra(&out);
          wra.apply(newroot);
          out.closeFile();

          newroot->unref();
        }

        return 0;
      }

Note: if VRML97 support is not present in the Coin library, this action does nothing and getVRML2SceneGraph always returns `NULL`.

See also:
  SoToVRMLAction

Since:
  Coin 2.0

  TGS Inventor 2.5

## Public Member Functions
| SoToVRML2Action (void)
virtual | ~SoToVRML2Action ()
virtual void | apply (SoNode *node)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
SoVRMLGroup * | getVRML2SceneGraph (void) const
void | reuseAppearanceNodes (SbBool appearance)
SbBool | doReuseAppearanceNodes (void) const
void | reusePropertyNodes (SbBool property)
SbBool | doReusePropertyNodes (void) const
void | reuseGeometryNodes (SbBool geometry)
SbBool | doReuseGeometryNodes (void) const
## Static Public Member Functions
void | initClass (void)
## Protected Member Functions
virtual void | beginTraversal (SoNode *node)
## Friends
class | SoToVRML2ActionP

## Constructor & Destructor Documentation

SoToVRML2Action::SoToVRML2Action | ( | void |  | ) |

| Constructor.

SoToVRML2Action::~SoToVRML2Action | ( | void |  | ) | `[virtual]`

| The destructor.

## Member Function Documentation

void SoToVRML2Action::initClass | ( | void |  | ) | `[static]`

| Initializes the run-time type system for this class, and sets up the enabled elements and action method list. Reimplemented from SoToVRMLAction.

void SoToVRML2Action::apply | ( | SoNode * | node | ) | `[virtual]`

| Applies the action to the scene graph rooted at root. Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined. Reimplemented from SoToVRMLAction.

void SoToVRML2Action::apply | ( | SoPath * | path | ) | `[virtual]`

| Applies the action to the parts of the graph defined by path. If the path ends in an SoGroup node, the action will also traverse the tail node's children. Reimplemented from SoToVRMLAction.

void SoToVRML2Action::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = FALSE
| ) | `[virtual]`

| Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions): All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path. Reimplemented from SoToVRMLAction.

SoVRMLGroup * SoToVRML2Action::getVRML2SceneGraph | ( | void |  | ) | const

| Return a pointer to the root node of the generated scenegraph of only VRML2 / VRML97 nodes. Will return `NULL` if VRML97 support was not compiled into the library.

void SoToVRML2Action::reuseAppearanceNodes | ( | SbBool | appearance | ) |

| Set the flag deciding if appearance nodes should be reused if possible. The default is FALSE. Please note that support for reusing Appearance nodes is not implemented yet.

SbBool SoToVRML2Action::doReuseAppearanceNodes | ( | void |  | ) | const

| Get the flag deciding if appearance nodes should be reused if possible. The default is FALSE. Please note that support for reusing Appearance nodes is not implemented yet, so this method will always return FALSE.

void SoToVRML2Action::reusePropertyNodes | ( | SbBool | property | ) |

| Set the flag deciding if property nodes should be reused if possible. The default is FALSE.

SbBool SoToVRML2Action::doReusePropertyNodes | ( | void |  | ) | const

| Get the flag deciding if property nodes should be reused if possible. The default is FALSE.

void SoToVRML2Action::reuseGeometryNodes | ( | SbBool | geometry | ) |

| Set the flag deciding if geometry nodes should be reused if possible. The default is FALSE. Please note that support for reusing Geometry nodes is not implemented yet.

SbBool SoToVRML2Action::doReuseGeometryNodes | ( | void |  | ) | const

| Get the flag deciding if geometry nodes should be reused if possible. The default is FALSE. Please note that support for reusing Geometry nodes is not implemented yet, so this function will always return FALSE.

void SoToVRML2Action::beginTraversal | ( | SoNode * | node | ) | `[protected, virtual]`

| This virtual method is called from SoAction::apply(), and is the entry point for the actual scenegraph traversal. It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction. Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scenegraph traversal. Reimplemented from SoToVRMLAction.

The documentation for this class was generated from the following files:

- SoToVRML2Action.h
- SoToVRML2Action.cpp